<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: reduced.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">reduced.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2008  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_REDUCEd_TRAINERS_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_REDUCEd_TRAINERS_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;reduced_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;function.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;kernel.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;kcentroid.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;linearly_independent_subset_finder.h&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;../optimization.h&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;{</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="keyword">typename</span> trainer_type </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        &gt;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classdlib_1_1reduced__decision__function__trainer.html">   25</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1reduced__decision__function__trainer.html">reduced_decision_function_trainer</a></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::kernel_type kernel_type;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::scalar_type scalar_type;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::sample_type sample_type;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::trained_function_type trained_function_type;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <a class="code" href="classdlib_1_1reduced__decision__function__trainer.html">reduced_decision_function_trainer</a> (</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        ) :num_bv(0) {}</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <a class="code" href="classdlib_1_1reduced__decision__function__trainer.html">reduced_decision_function_trainer</a> (</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;            <span class="keyword">const</span> trainer_type&amp; trainer_,</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_sb_ </div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        ) :</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            trainer(trainer_),</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            num_bv(num_sb_)</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            DLIB_ASSERT(num_bv &gt; 0,</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;                        <span class="stringliteral">&quot;\t reduced_decision_function_trainer()&quot;</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot;\n\t you have given invalid arguments to this function&quot;</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot;\n\t num_bv: &quot;</span> &lt;&lt; num_bv </div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            );</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        }</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;            <span class="keyword">typename</span> in_sample_vector_type,</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;            <span class="keyword">typename</span> in_scalar_vector_type</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            &gt;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keyword">const</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a> train (</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            <span class="keyword">const</span> in_sample_vector_type&amp; x,</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            <span class="keyword">const</span> in_scalar_vector_type&amp; y</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            DLIB_ASSERT(num_bv &gt; 0,</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;                        <span class="stringliteral">&quot;\t reduced_decision_function_trainer::train(x,y)&quot;</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot;\n\t You have tried to use an uninitialized version of this object&quot;</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot;\n\t num_bv: &quot;</span> &lt;&lt; num_bv );</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            <span class="keywordflow">return</span> do_train(mat(x), mat(y));</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        }</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <span class="keyword">typename</span> in_sample_vector_type,</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <span class="keyword">typename</span> in_scalar_vector_type</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            &gt;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keyword">const</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a> do_train (</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;            <span class="keyword">const</span> in_sample_vector_type&amp; x,</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            <span class="keyword">const</span> in_scalar_vector_type&amp; y</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            <span class="comment">// get the decision function object we are going to try and approximate</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            <span class="keyword">const</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a>&amp; dec_funct = trainer.train(x,y);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            </div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            <span class="comment">// now find a linearly independent subset of the training points of num_bv points.</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;            <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html">linearly_independent_subset_finder&lt;kernel_type&gt;</a> lisf(dec_funct.kernel_function, num_bv);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            fill_lisf(lisf, x);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            <span class="comment">// The next few statements just find the best weights with which to approximate </span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            <span class="comment">// the dec_funct object with the smaller set of vectors in the lisf dictionary.  This</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="comment">// is really just a simple application of some linear algebra.  For the details </span></div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            <span class="comment">// see page 554 of Learning with kernels by Scholkopf and Smola where they talk </span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            <span class="comment">// about &quot;Optimal Expansion Coefficients.&quot;</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            <span class="keyword">const</span> kernel_type kern(dec_funct.kernel_function);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,1,mem_manager_type&gt;</a> alpha;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            alpha = lisf.get_inv_kernel_marix()*(kernel_matrix(kern,lisf,dec_funct.basis_vectors)*dec_funct.alpha);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a> new_df(alpha, </div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;                                                  0,</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;                                                  kern, </div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                                                  lisf.get_dictionary());</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            <span class="comment">// now we have to figure out what the new bias should be.  It might be a little</span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            <span class="comment">// different since we just messed with all the weights and vectors.</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;            <span class="keywordtype">double</span> bias = 0;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; x.nr(); ++i)</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            {</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;                bias += new_df(x(i)) - dec_funct(x(i));</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;            }</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            </div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            new_df.b = bias/x.nr();</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            <span class="keywordflow">return</span> new_df;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        }</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160; </div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        trainer_type trainer;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_bv; </div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160; </div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160; </div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    }; <span class="comment">// end of class reduced_decision_function_trainer</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160; </div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> trainer_type&gt;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1reduced__decision__function__trainer.html">reduced_decision_function_trainer&lt;trainer_type&gt;</a> reduced (</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        <span class="keyword">const</span> trainer_type&amp; trainer,</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_bv</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    )</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    {</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        DLIB_ASSERT(num_bv &gt; 0,</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;                    <span class="stringliteral">&quot;\tconst reduced_decision_function_trainer reduced()&quot;</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t you have given invalid arguments to this function&quot;</span></div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t num_bv: &quot;</span> &lt;&lt; num_bv </div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        );</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classdlib_1_1reduced__decision__function__trainer.html">reduced_decision_function_trainer&lt;trainer_type&gt;</a>(trainer, num_bv);</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    }</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160; </div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <span class="keyword">namespace </span>red_impl</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    {</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160; </div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160; </div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> kernel_type&gt;</div><div class="line"><a name="l00153"></a><span class="lineno"><a class="line" href="classdlib_1_1red__impl_1_1objective.html">  153</a></span>&#160;        <span class="keyword">class </span><a class="code" href="classdlib_1_1red__impl_1_1objective.html">objective</a></div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        {</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <span class="comment">/*</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment">                This object represents the objective function we will try to</span></div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment">                minimize in approximate_distance_function().  </span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="comment"></span> </div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="comment">                The objective is the distance, in kernel induced feature space, between</span></div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="comment">                the original distance function and the approximated version.</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment"></span> </div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment">            */</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::scalar_type scalar_type;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::sample_type sample_type;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        <span class="keyword">public</span>:</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            <a class="code" href="classdlib_1_1red__impl_1_1objective.html">objective</a>(</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                <span class="keyword">const</span> <a class="code" href="classdlib_1_1distance__function.html">distance_function&lt;kernel_type&gt;</a>&amp; dist_funct_,</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,1,mem_manager_type&gt;</a>&amp; b_,</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;                <a class="code" href="classdlib_1_1matrix.html">matrix&lt;sample_type,0,1,mem_manager_type&gt;</a>&amp; out_vectors_</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            ) :</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;                dist_funct(dist_funct_),</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;                b(b_),</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;                out_vectors(out_vectors_)</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;            {</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            }</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160; </div><div class="line"><a name="l00178"></a><span class="lineno"><a class="line" href="classdlib_1_1red__impl_1_1objective.html#a19e7cbde95a4b34315b1a350bd1906a1">  178</a></span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type, 0, 1, mem_manager_type&gt;</a> <a class="code" href="classdlib_1_1red__impl_1_1objective.html#a19e7cbde95a4b34315b1a350bd1906a1">state_to_vector</a> (</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;            ) const</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;            {</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;                <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type, 0, 1, mem_manager_type&gt;</a> z(b.nr() + out_vectors.size()*out_vectors(0).nr());</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                <span class="keywordtype">long</span> i = 0;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; b.nr(); ++j)</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                {</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                    z(i) = b(j);</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                    ++i;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;                }</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160; </div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; out_vectors.size(); ++j)</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;                {</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">long</span> k = 0; k &lt; out_vectors(j).size(); ++k)</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;                    {</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;                        z(i) = out_vectors(j)(k);</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                        ++i;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;                    }</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;                }</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;                <span class="keywordflow">return</span> z;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;            }</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160; </div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160; </div><div class="line"><a name="l00206"></a><span class="lineno"><a class="line" href="classdlib_1_1red__impl_1_1objective.html#a08167a36f2c6503ba99ea15051837ca5">  206</a></span>&#160;            <span class="keywordtype">void</span> <a class="code" href="classdlib_1_1red__impl_1_1objective.html#a08167a36f2c6503ba99ea15051837ca5">vector_to_state</a> (</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;                <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type, 0, 1, mem_manager_type&gt;</a>&amp; z</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            ) <span class="keyword">const</span></div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            {</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;                <span class="keywordtype">long</span> i = 0;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; b.nr(); ++j)</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;                {</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;                    b(j) = z(i);</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                    ++i;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                }</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160; </div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; out_vectors.size(); ++j)</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;                {</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">long</span> k = 0; k &lt; out_vectors(j).size(); ++k)</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;                    {</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;                        out_vectors(j)(k) = z(i);</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;                        ++i;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;                    }</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;                }</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;            }</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160; </div><div class="line"><a name="l00234"></a><span class="lineno"><a class="line" href="classdlib_1_1red__impl_1_1objective.html#ad85ad84ee86e5d4d6e8bd8650dc86af1">  234</a></span>&#160;            <span class="keywordtype">double</span> <a class="code" href="classdlib_1_1red__impl_1_1objective.html#ad85ad84ee86e5d4d6e8bd8650dc86af1">operator() </a>(</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;                <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type, 0, 1, mem_manager_type&gt;</a>&amp; z</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;            ) <span class="keyword">const</span></div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            {</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;                <a class="code" href="classdlib_1_1red__impl_1_1objective.html#a08167a36f2c6503ba99ea15051837ca5">vector_to_state</a>(z);</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;                <span class="keyword">const</span> kernel_type k(dist_funct.get_kernel());</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160; </div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;                <span class="keywordtype">double</span> temp = 0;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; out_vectors.size(); ++i)</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;                {</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; dist_funct.get_basis_vectors().nr(); ++j)</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;                    {</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;                        temp -= b(i)*dist_funct.get_alpha()(j)*k(out_vectors(i), dist_funct.get_basis_vectors()(j));</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;                    }</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;                }</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160; </div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;                temp *= 2;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160; </div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; out_vectors.size(); ++i)</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;                {</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; out_vectors.size(); ++j)</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;                    {</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                        temp += b(i)*b(j)*k(out_vectors(i), out_vectors(j));</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                    }</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;                }</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160; </div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;                <span class="keywordflow">return</span> temp + dist_funct.get_squared_norm();</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;            }</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160; </div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        <span class="keyword">private</span>:</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160; </div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1distance__function.html">distance_function&lt;kernel_type&gt;</a>&amp; dist_funct;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;            <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,1,mem_manager_type&gt;</a>&amp; b;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            <a class="code" href="classdlib_1_1matrix.html">matrix&lt;sample_type,0,1,mem_manager_type&gt;</a>&amp; out_vectors;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160; </div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        };</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160; </div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160; </div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> kernel_type&gt;</div><div class="line"><a name="l00280"></a><span class="lineno"><a class="line" href="classdlib_1_1red__impl_1_1objective__derivative.html">  280</a></span>&#160;        <span class="keyword">class </span><a class="code" href="classdlib_1_1red__impl_1_1objective__derivative.html">objective_derivative</a></div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        {</div><div class="line"><a name="l00285"></a><span class="lineno"><a class="line" href="classdlib_1_1red__impl_1_1objective__derivative.html#a695ee22d78dc7c746d5189f954a4fa18">  285</a></span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::scalar_type <a class="code" href="classdlib_1_1red__impl_1_1objective__derivative.html#a695ee22d78dc7c746d5189f954a4fa18">scalar_type</a>;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::sample_type sample_type;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        <span class="keyword">public</span>:</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160; </div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160; </div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;            <a class="code" href="classdlib_1_1red__impl_1_1objective__derivative.html">objective_derivative</a>(</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;                <span class="keyword">const</span> <a class="code" href="classdlib_1_1distance__function.html">distance_function&lt;kernel_type&gt;</a>&amp; dist_funct_,</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;                <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,1,mem_manager_type&gt;</a>&amp; b_,</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;                <a class="code" href="classdlib_1_1matrix.html">matrix&lt;sample_type,0,1,mem_manager_type&gt;</a>&amp; out_vectors_</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            ) :</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;                dist_funct(dist_funct_),</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;                b(b_),</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;                out_vectors(out_vectors_)</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            {</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;            }</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160; </div><div class="line"><a name="l00302"></a><span class="lineno"><a class="line" href="classdlib_1_1red__impl_1_1objective__derivative.html#a07724122fa7828ae2e17fab8d2b34482">  302</a></span>&#160;            <span class="keywordtype">void</span> <a class="code" href="classdlib_1_1red__impl_1_1objective__derivative.html#a07724122fa7828ae2e17fab8d2b34482">vector_to_state</a> (</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;                <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type, 0, 1, mem_manager_type&gt;</a>&amp; z</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;            ) <span class="keyword">const</span></div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;            {</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;                <span class="keywordtype">long</span> i = 0;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; b.nr(); ++j)</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;                {</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;                    b(j) = z(i);</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;                    ++i;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;                }</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160; </div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; out_vectors.size(); ++j)</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;                {</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">long</span> k = 0; k &lt; out_vectors(j).size(); ++k)</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;                    {</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;                        out_vectors(j)(k) = z(i);</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;                        ++i;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;                    }</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;                }</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;            }</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160; </div><div class="line"><a name="l00330"></a><span class="lineno"><a class="line" href="classdlib_1_1red__impl_1_1objective__derivative.html#abd5eda7aece09b0f4be2e39bf3fa9ffd">  330</a></span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,1,mem_manager_type&gt;</a>&amp; <a class="code" href="classdlib_1_1red__impl_1_1objective__derivative.html#abd5eda7aece09b0f4be2e39bf3fa9ffd">operator() </a>(</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;                <span class="keyword">const</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type, 0, 1, mem_manager_type&gt;</a>&amp; z</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;            ) <span class="keyword">const</span></div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;            {</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;                <a class="code" href="classdlib_1_1red__impl_1_1objective__derivative.html#a07724122fa7828ae2e17fab8d2b34482">vector_to_state</a>(z);</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;                res.set_size(z.nr());</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;                set_all_elements(res,0);</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;                <span class="keyword">const</span> kernel_type k(dist_funct.get_kernel());</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;                <span class="keyword">const</span> <a class="code" href="structdlib_1_1kernel__derivative.html">kernel_derivative&lt;kernel_type&gt;</a> K_der(k);</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160; </div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;                <span class="comment">// first compute the gradient for the beta weights</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; out_vectors.size(); ++i)</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;                {</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; out_vectors.size(); ++j)</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;                    {</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;                        res(i) += b(j)*k(out_vectors(i), out_vectors(j)); </div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;                    }</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;                }</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; out_vectors.size(); ++i)</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;                {</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; dist_funct.get_basis_vectors().size(); ++j)</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;                    {</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;                        res(i) -= dist_funct.get_alpha()(j)*k(out_vectors(i), dist_funct.get_basis_vectors()(j)); </div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;                    }</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;                }</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160; </div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160; </div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;                <span class="comment">// now compute the gradient of the actual vectors that go into the kernel functions</span></div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;                <span class="keywordtype">long</span> pos = out_vectors.size();</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;                <span class="keyword">const</span> <span class="keywordtype">long</span> num = out_vectors(0).nr();</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;                temp.set_size(num,1);</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; out_vectors.size(); ++i)</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;                {</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;                    set_all_elements(temp,0);</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; out_vectors.size(); ++j)</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;                    {</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;                        temp += b(j)*K_der(out_vectors(j), out_vectors(i));</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;                    }</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">long</span> j = 0; j &lt; dist_funct.get_basis_vectors().nr(); ++j)</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;                    {</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;                        temp -= dist_funct.get_alpha()(j)*K_der(dist_funct.get_basis_vectors()(j), out_vectors(i) );</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;                    }</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160; </div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;                    <span class="comment">// store the gradient for out_vectors(i) into result in the proper spot</span></div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;                    set_subm(res,pos,0,num,1) = b(i)*temp;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;                    pos += num;</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;                }</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160; </div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160; </div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;                res *= 2;</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;                <span class="keywordflow">return</span> res;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;            }</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160; </div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;        <span class="keyword">private</span>:</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160; </div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;            <span class="keyword">mutable</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type, 0, 1, mem_manager_type&gt;</a> res;</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;            <span class="keyword">mutable</span> sample_type temp;</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160; </div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1distance__function.html">distance_function&lt;kernel_type&gt;</a>&amp; dist_funct;</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;            <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,1,mem_manager_type&gt;</a>&amp; b;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;            <a class="code" href="classdlib_1_1matrix.html">matrix&lt;sample_type,0,1,mem_manager_type&gt;</a>&amp; out_vectors;</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160; </div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;        };</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160; </div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160; </div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;    }</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160; </div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;        <span class="keyword">typename</span> K,</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;        <span class="keyword">typename</span> stop_strategy_type,</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;        &gt;</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;    distance_function&lt;K&gt; approximate_distance_function (</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;        stop_strategy_type stop_strategy,</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        <span class="keyword">const</span> distance_function&lt;K&gt;&amp; target,</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        <span class="keyword">const</span> T&amp; starting_basis</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    )</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    {</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;        DLIB_ASSERT(target.get_basis_vectors().size() &gt; 0 &amp;&amp;</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;                    starting_basis.size() &gt; 0,</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;                    <span class="stringliteral">&quot;\t  distance_function approximate_distance_function()&quot;</span></div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t Invalid inputs were given to this function.&quot;</span></div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t target.get_basis_vectors().size(): &quot;</span> &lt;&lt; target.get_basis_vectors().size() </div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t starting_basis.size():             &quot;</span> &lt;&lt; starting_basis.size() </div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;        );</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160; </div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;        <span class="keyword">using namespace </span>red_impl;</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;        <span class="comment">// The next few statements just find the best weights with which to approximate </span></div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;        <span class="comment">// the target object with the set of basis vectors in starting_basis.  This</span></div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;        <span class="comment">// is really just a simple application of some linear algebra.  For the details </span></div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;        <span class="comment">// see page 554 of Learning with kernels by Scholkopf and Smola where they talk </span></div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;        <span class="comment">// about &quot;Optimal Expansion Coefficients.&quot;</span></div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160; </div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;        <span class="keyword">const</span> K kern(target.get_kernel());</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> K::scalar_type scalar_type;</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> K::sample_type sample_type;</div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> K::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160; </div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;        matrix&lt;scalar_type,0,1,mem_manager_type&gt; beta;</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160; </div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;        <span class="comment">// Now we compute the fist approximate distance function.  </span></div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;        beta = pinv(kernel_matrix(kern,starting_basis)) *</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;            (kernel_matrix(kern,starting_basis,target.get_basis_vectors())*target.get_alpha());</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;        matrix&lt;sample_type,0,1,mem_manager_type&gt; out_vectors(mat(starting_basis));</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160; </div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160; </div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;        <span class="comment">// Now setup to do a global optimization of all the parameters in the approximate </span></div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;        <span class="comment">// distance function.  </span></div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;        <span class="keyword">const</span> objective&lt;K&gt; obj(target, beta, out_vectors);</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;        <span class="keyword">const</span> objective_derivative&lt;K&gt; obj_der(target, beta, out_vectors);</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;        matrix&lt;scalar_type,0,1,mem_manager_type&gt; opt_starting_point(obj.state_to_vector());</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160; </div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160; </div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;        <span class="comment">// perform a full optimization of all the parameters (i.e. both beta and the basis vectors together)</span></div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;        find_min(lbfgs_search_strategy(20),</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;                 stop_strategy,</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;                 obj, obj_der, opt_starting_point, 0); </div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160; </div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;        <span class="comment">// now make sure that the final optimized value is loaded into the beta and</span></div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;        <span class="comment">// out_vectors matrices</span></div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;        obj.vector_to_state(opt_starting_point);</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160; </div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;        <span class="comment">// Do a final reoptimization of beta just to make sure it is optimal given the new</span></div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;        <span class="comment">// set of basis vectors.</span></div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;        beta = pinv(kernel_matrix(kern,out_vectors))*(kernel_matrix(kern,out_vectors,target.get_basis_vectors())*target.get_alpha());</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160; </div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;        <span class="comment">// It is possible that some of the beta weights will be very close to zero.  Lets remove</span></div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;        <span class="comment">// the basis vectors with these essentially zero weights.</span></div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;        <span class="keyword">const</span> scalar_type eps = max(abs(beta))*std::numeric_limits&lt;scalar_type&gt;::epsilon();</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; beta.size(); ++i)</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;        {</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;            <span class="comment">// if beta(i) is zero (but leave at least one beta no matter what)</span></div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;            <span class="keywordflow">if</span> (std::abs(beta(i)) &lt; eps &amp;&amp; beta.size() &gt; 1)</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;            {</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;                beta = remove_row(beta, i);</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;                out_vectors = remove_row(out_vectors, i);</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;                --i;</div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;            }</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;        }</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160; </div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;        <span class="keywordflow">return</span> distance_function&lt;K&gt;(beta, kern, out_vectors);</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;    }</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160; </div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160; </div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;        <span class="keyword">typename</span> trainer_type </div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;        &gt;</div><div class="line"><a name="l00488"></a><span class="lineno"><a class="line" href="classdlib_1_1reduced__decision__function__trainer2.html">  488</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1reduced__decision__function__trainer2.html">reduced_decision_function_trainer2</a></div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;    {</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::kernel_type kernel_type;</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::scalar_type scalar_type;</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::sample_type sample_type;</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::trained_function_type trained_function_type;</div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160; </div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;        <a class="code" href="classdlib_1_1reduced__decision__function__trainer2.html">reduced_decision_function_trainer2</a> () : num_bv(0) {}</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;        <a class="code" href="classdlib_1_1reduced__decision__function__trainer2.html">reduced_decision_function_trainer2</a> (</div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;            <span class="keyword">const</span> trainer_type&amp; trainer_,</div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">long</span> num_sb_,</div><div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> eps_ = 1e-3</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;        ) :</div><div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;            trainer(trainer_),</div><div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;            num_bv(num_sb_),</div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;            eps(eps_)</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;        {</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;            COMPILE_TIME_ASSERT(<a class="code" href="structdlib_1_1is__matrix.html">is_matrix&lt;sample_type&gt;::value</a>);</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160; </div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;            DLIB_ASSERT(num_bv &gt; 0 &amp;&amp; eps &gt; 0,</div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;                        <span class="stringliteral">&quot;\t reduced_decision_function_trainer2()&quot;</span></div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot;\n\t you have given invalid arguments to this function&quot;</span></div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot;\n\t num_bv: &quot;</span> &lt;&lt; num_bv </div><div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot;\n\t eps:    &quot;</span> &lt;&lt; eps </div><div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;            );</div><div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;        }</div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160; </div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;            <span class="keyword">typename</span> in_sample_vector_type,</div><div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;            <span class="keyword">typename</span> in_scalar_vector_type</div><div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;            &gt;</div><div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;        <span class="keyword">const</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a> train (</div><div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;            <span class="keyword">const</span> in_sample_vector_type&amp; x,</div><div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;            <span class="keyword">const</span> in_scalar_vector_type&amp; y</div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00528"></a><span class="lineno">  528</span>&#160;            DLIB_ASSERT(num_bv &gt; 0,</div><div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;                        <span class="stringliteral">&quot;\t reduced_decision_function_trainer2::train(x,y)&quot;</span></div><div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot;\n\t You have tried to use an uninitialized version of this object&quot;</span></div><div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot;\n\t num_bv: &quot;</span> &lt;&lt; num_bv );</div><div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;            <span class="keywordflow">return</span> do_train(mat(x), mat(y));</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;        }</div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160; </div><div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160; </div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;            <span class="keyword">typename</span> in_sample_vector_type,</div><div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;            <span class="keyword">typename</span> in_scalar_vector_type</div><div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;            &gt;</div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;        <span class="keyword">const</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a> do_train (</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;            <span class="keyword">const</span> in_sample_vector_type&amp; x,</div><div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;            <span class="keyword">const</span> in_scalar_vector_type&amp; y</div><div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;            <span class="comment">// get the decision function object we are going to try and approximate</span></div><div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;            <span class="keyword">const</span> <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a>&amp; dec_funct = trainer.train(x,y);</div><div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160;            <span class="keyword">const</span> kernel_type kern(dec_funct.kernel_function);</div><div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;            </div><div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;            <span class="comment">// now find a linearly independent subset of the training points of num_bv points.</span></div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;            <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html">linearly_independent_subset_finder&lt;kernel_type&gt;</a> lisf(kern, num_bv);</div><div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;            fill_lisf(lisf,x);</div><div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160; </div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;            <a class="code" href="classdlib_1_1distance__function.html">distance_function&lt;kernel_type&gt;</a> approx, target;</div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;            target = dec_funct;</div><div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;            approx = approximate_distance_function(<a class="code" href="classdlib_1_1objective__delta__stop__strategy.html">objective_delta_stop_strategy</a>(eps), target, lisf);</div><div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160; </div><div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;            <a class="code" href="structdlib_1_1decision__function.html">decision_function&lt;kernel_type&gt;</a> new_df(approx.get_alpha(), </div><div class="line"><a name="l00559"></a><span class="lineno">  559</span>&#160;                                                  0,</div><div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;                                                  kern, </div><div class="line"><a name="l00561"></a><span class="lineno">  561</span>&#160;                                                  approx.get_basis_vectors());</div><div class="line"><a name="l00562"></a><span class="lineno">  562</span>&#160; </div><div class="line"><a name="l00563"></a><span class="lineno">  563</span>&#160;            <span class="comment">// now we have to figure out what the new bias should be.  It might be a little</span></div><div class="line"><a name="l00564"></a><span class="lineno">  564</span>&#160;            <span class="comment">// different since we just messed with all the weights and vectors.</span></div><div class="line"><a name="l00565"></a><span class="lineno">  565</span>&#160;            <span class="keywordtype">double</span> bias = 0;</div><div class="line"><a name="l00566"></a><span class="lineno">  566</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; x.nr(); ++i)</div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;            {</div><div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;                bias += new_df(x(i)) - dec_funct(x(i));</div><div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;            }</div><div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;            </div><div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;            new_df.b = bias/x.nr();</div><div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160; </div><div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;            <span class="keywordflow">return</span> new_df;</div><div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160; </div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;        }</div><div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160; </div><div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;    <span class="comment">// ------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160; </div><div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160;        trainer_type trainer;</div><div class="line"><a name="l00580"></a><span class="lineno">  580</span>&#160;        <span class="keywordtype">long</span> num_bv;</div><div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;        <span class="keywordtype">double</span> eps;</div><div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160; </div><div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160; </div><div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;    }; <span class="comment">// end of class reduced_decision_function_trainer2</span></div><div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160; </div><div class="line"><a name="l00586"></a><span class="lineno">  586</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> trainer_type&gt;</div><div class="line"><a name="l00587"></a><span class="lineno">  587</span>&#160;    <span class="keyword">const</span> <a class="code" href="classdlib_1_1reduced__decision__function__trainer2.html">reduced_decision_function_trainer2&lt;trainer_type&gt;</a> reduced2 (</div><div class="line"><a name="l00588"></a><span class="lineno">  588</span>&#160;        <span class="keyword">const</span> trainer_type&amp; trainer,</div><div class="line"><a name="l00589"></a><span class="lineno">  589</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> num_bv,</div><div class="line"><a name="l00590"></a><span class="lineno">  590</span>&#160;        <span class="keywordtype">double</span> eps = 1e-3</div><div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160;    )</div><div class="line"><a name="l00592"></a><span class="lineno">  592</span>&#160;    {</div><div class="line"><a name="l00593"></a><span class="lineno">  593</span>&#160;        COMPILE_TIME_ASSERT(<a class="code" href="structdlib_1_1is__matrix.html">is_matrix&lt;typename trainer_type::sample_type&gt;::value</a>);</div><div class="line"><a name="l00594"></a><span class="lineno">  594</span>&#160; </div><div class="line"><a name="l00595"></a><span class="lineno">  595</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00596"></a><span class="lineno">  596</span>&#160;        DLIB_ASSERT(num_bv &gt; 0 &amp;&amp; eps &gt; 0,</div><div class="line"><a name="l00597"></a><span class="lineno">  597</span>&#160;                    <span class="stringliteral">&quot;\tconst reduced_decision_function_trainer2 reduced2()&quot;</span></div><div class="line"><a name="l00598"></a><span class="lineno">  598</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t you have given invalid arguments to this function&quot;</span></div><div class="line"><a name="l00599"></a><span class="lineno">  599</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t num_bv: &quot;</span> &lt;&lt; num_bv </div><div class="line"><a name="l00600"></a><span class="lineno">  600</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t eps:    &quot;</span> &lt;&lt; eps </div><div class="line"><a name="l00601"></a><span class="lineno">  601</span>&#160;        );</div><div class="line"><a name="l00602"></a><span class="lineno">  602</span>&#160; </div><div class="line"><a name="l00603"></a><span class="lineno">  603</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classdlib_1_1reduced__decision__function__trainer2.html">reduced_decision_function_trainer2&lt;trainer_type&gt;</a>(trainer, num_bv, eps);</div><div class="line"><a name="l00604"></a><span class="lineno">  604</span>&#160;    }</div><div class="line"><a name="l00605"></a><span class="lineno">  605</span>&#160; </div><div class="line"><a name="l00606"></a><span class="lineno">  606</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00608"></a><span class="lineno">  608</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00609"></a><span class="lineno">  609</span>&#160; </div><div class="line"><a name="l00610"></a><span class="lineno">  610</span>&#160;}</div><div class="line"><a name="l00611"></a><span class="lineno">  611</span>&#160; </div><div class="line"><a name="l00612"></a><span class="lineno">  612</span>&#160;<span class="preprocessor">#endif // DLIB_REDUCEd_TRAINERS_</span></div><div class="line"><a name="l00613"></a><span class="lineno">  613</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1red__impl_1_1objective_html_a19e7cbde95a4b34315b1a350bd1906a1"><div class="ttname"><a href="classdlib_1_1red__impl_1_1objective.html#a19e7cbde95a4b34315b1a350bd1906a1">dlib::red_impl::objective::state_to_vector</a></div><div class="ttdeci">const matrix&lt; scalar_type, 0, 1, mem_manager_type &gt; state_to_vector() const</div><div class="ttdef"><b>Definition:</b> reduced.h:178</div></div>
<div class="ttc" id="aclassdlib_1_1distance__function_html"><div class="ttname"><a href="classdlib_1_1distance__function.html">dlib::distance_function&lt; kernel_type &gt;</a></div></div>
<div class="ttc" id="aclassdlib_1_1red__impl_1_1objective__derivative_html_a07724122fa7828ae2e17fab8d2b34482"><div class="ttname"><a href="classdlib_1_1red__impl_1_1objective__derivative.html#a07724122fa7828ae2e17fab8d2b34482">dlib::red_impl::objective_derivative::vector_to_state</a></div><div class="ttdeci">void vector_to_state(const matrix&lt; scalar_type, 0, 1, mem_manager_type &gt; &amp;z) const</div><div class="ttdef"><b>Definition:</b> reduced.h:302</div></div>
<div class="ttc" id="aclassdlib_1_1reduced__decision__function__trainer2_html"><div class="ttname"><a href="classdlib_1_1reduced__decision__function__trainer2.html">dlib::reduced_decision_function_trainer2</a></div><div class="ttdef"><b>Definition:</b> reduced.h:488</div></div>
<div class="ttc" id="aclassdlib_1_1reduced__decision__function__trainer_html"><div class="ttname"><a href="classdlib_1_1reduced__decision__function__trainer.html">dlib::reduced_decision_function_trainer</a></div><div class="ttdef"><b>Definition:</b> reduced.h:25</div></div>
<div class="ttc" id="aclassdlib_1_1objective__delta__stop__strategy_html"><div class="ttname"><a href="classdlib_1_1objective__delta__stop__strategy.html">dlib::objective_delta_stop_strategy</a></div><div class="ttdef"><b>Definition:</b> optimization_stop_strategies.h:18</div></div>
<div class="ttc" id="aclassdlib_1_1red__impl_1_1objective__derivative_html"><div class="ttname"><a href="classdlib_1_1red__impl_1_1objective__derivative.html">dlib::red_impl::objective_derivative</a></div><div class="ttdef"><b>Definition:</b> reduced.h:280</div></div>
<div class="ttc" id="aclassdlib_1_1linearly__independent__subset__finder_html"><div class="ttname"><a href="classdlib_1_1linearly__independent__subset__finder.html">dlib::linearly_independent_subset_finder</a></div><div class="ttdef"><b>Definition:</b> linearly_independent_subset_finder.h:24</div></div>
<div class="ttc" id="astructdlib_1_1is__matrix_html"><div class="ttname"><a href="structdlib_1_1is__matrix.html">dlib::is_matrix</a></div><div class="ttdef"><b>Definition:</b> is_kind.h:49</div></div>
<div class="ttc" id="aclassdlib_1_1red__impl_1_1objective__derivative_html_abd5eda7aece09b0f4be2e39bf3fa9ffd"><div class="ttname"><a href="classdlib_1_1red__impl_1_1objective__derivative.html#abd5eda7aece09b0f4be2e39bf3fa9ffd">dlib::red_impl::objective_derivative::operator()</a></div><div class="ttdeci">const matrix&lt; scalar_type, 0, 1, mem_manager_type &gt; &amp; operator()(const matrix&lt; scalar_type, 0, 1, mem_manager_type &gt; &amp;z) const</div><div class="ttdef"><b>Definition:</b> reduced.h:330</div></div>
<div class="ttc" id="aclassdlib_1_1red__impl_1_1objective_html_ad85ad84ee86e5d4d6e8bd8650dc86af1"><div class="ttname"><a href="classdlib_1_1red__impl_1_1objective.html#ad85ad84ee86e5d4d6e8bd8650dc86af1">dlib::red_impl::objective::operator()</a></div><div class="ttdeci">double operator()(const matrix&lt; scalar_type, 0, 1, mem_manager_type &gt; &amp;z) const</div><div class="ttdef"><b>Definition:</b> reduced.h:234</div></div>
<div class="ttc" id="aclassdlib_1_1red__impl_1_1objective_html"><div class="ttname"><a href="classdlib_1_1red__impl_1_1objective.html">dlib::red_impl::objective</a></div><div class="ttdef"><b>Definition:</b> reduced.h:153</div></div>
<div class="ttc" id="aclassdlib_1_1matrix_html"><div class="ttname"><a href="classdlib_1_1matrix.html">dlib::matrix&lt; scalar_type, 0, 1, mem_manager_type &gt;</a></div></div>
<div class="ttc" id="aclassdlib_1_1red__impl_1_1objective__derivative_html_a695ee22d78dc7c746d5189f954a4fa18"><div class="ttname"><a href="classdlib_1_1red__impl_1_1objective__derivative.html#a695ee22d78dc7c746d5189f954a4fa18">dlib::red_impl::objective_derivative::scalar_type</a></div><div class="ttdeci">kernel_type::scalar_type scalar_type</div><div class="ttdef"><b>Definition:</b> reduced.h:285</div></div>
<div class="ttc" id="astructdlib_1_1decision__function_html"><div class="ttname"><a href="structdlib_1_1decision__function.html">dlib::decision_function</a></div><div class="ttdef"><b>Definition:</b> function.h:27</div></div>
<div class="ttc" id="astructdlib_1_1kernel__derivative_html"><div class="ttname"><a href="structdlib_1_1kernel__derivative.html">dlib::kernel_derivative</a></div><div class="ttdef"><b>Definition:</b> kernel.h:19</div></div>
<div class="ttc" id="aclassdlib_1_1red__impl_1_1objective_html_a08167a36f2c6503ba99ea15051837ca5"><div class="ttname"><a href="classdlib_1_1red__impl_1_1objective.html#a08167a36f2c6503ba99ea15051837ca5">dlib::red_impl::objective::vector_to_state</a></div><div class="ttdeci">void vector_to_state(const matrix&lt; scalar_type, 0, 1, mem_manager_type &gt; &amp;z) const</div><div class="ttdef"><b>Definition:</b> reduced.h:206</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
